diff --git a/fs/btrfs/delayed-ref.c b/fs/btrfs/delayed-ref.c
index 342f32ae08c9..a3eb3eb2f321 100644
--- a/fs/btrfs/delayed-ref.c
+++ b/fs/btrfs/delayed-ref.c
@@ -874,7 +874,7 @@ static void init_delayed_ref_head(struct btrfs_delayed_ref_head *head_ref,
 
 	refcount_set(&head_ref->refs, 1);
 	head_ref->bytenr = generic_ref->bytenr;
-	head_ref->num_bytes = generic_ref->len;
+	head_ref->num_bytes = generic_ref->num_bytes;
 	head_ref->ref_mod = count_mod;
 	head_ref->reserved_bytes = reserved;
 	head_ref->must_insert_reserved = must_insert_reserved;
@@ -895,7 +895,7 @@ static void init_delayed_ref_head(struct btrfs_delayed_ref_head *head_ref,
 			qrecord->data_rsv_refroot = generic_ref->ref_root;
 		}
 		qrecord->bytenr = generic_ref->bytenr;
-		qrecord->num_bytes = generic_ref->len;
+		qrecord->num_bytes = generic_ref->num_bytes;
 		qrecord->old_roots = NULL;
 	}
 }
@@ -1000,7 +1000,7 @@ static void init_delayed_ref_common(struct btrfs_fs_info *fs_info,
 
 	refcount_set(&ref->refs, 1);
 	ref->bytenr = generic_ref->bytenr;
-	ref->num_bytes = generic_ref->len;
+	ref->num_bytes = generic_ref->num_bytes;
 	ref->ref_mod = 1;
 	ref->action = action;
 	ref->seq = seq;
@@ -1157,7 +1157,7 @@ int btrfs_add_delayed_extent_op(struct btrfs_trans_handle *trans,
 		.type = BTRFS_REF_METADATA,
 		.action = BTRFS_UPDATE_DELAYED_HEAD,
 		.bytenr = bytenr,
-		.len = num_bytes,
+		.num_bytes = num_bytes,
 	};
 
 	head_ref = kmem_cache_alloc(btrfs_delayed_ref_head_cachep, GFP_NOFS);
diff --git a/fs/btrfs/delayed-ref.h b/fs/btrfs/delayed-ref.h
index 83fcb32715a4..000fdcaf2314 100644
--- a/fs/btrfs/delayed-ref.h
+++ b/fs/btrfs/delayed-ref.h
@@ -260,7 +260,7 @@ struct btrfs_ref {
 	u64 real_root;
 #endif
 	u64 bytenr;
-	u64 len;
+	u64 num_bytes;
 	u64 owning_root;
 
 	/*
diff --git a/fs/btrfs/extent-tree.c b/fs/btrfs/extent-tree.c
index 805e3e904368..268516003927 100644
--- a/fs/btrfs/extent-tree.c
+++ b/fs/btrfs/extent-tree.c
@@ -2542,7 +2542,7 @@ static int __btrfs_mod_ref(struct btrfs_trans_handle *trans,
 			if (ref.bytenr == 0)
 				continue;
 
-			ref.len = btrfs_file_extent_disk_num_bytes(buf, fi);
+			ref.num_bytes = btrfs_file_extent_disk_num_bytes(buf, fi);
 			ref.owning_root = ref_root;
 
 			key.offset -= btrfs_file_extent_offset(buf, fi);
@@ -2557,7 +2557,7 @@ static int __btrfs_mod_ref(struct btrfs_trans_handle *trans,
 		} else {
 			/* We don't know the owning_root, leave as 0. */
 			ref.bytenr = btrfs_node_blockptr(buf, i);
-			ref.len = fs_info->nodesize;
+			ref.num_bytes = fs_info->nodesize;
 
 			btrfs_init_tree_ref(&ref, level - 1,
 					    root->root_key.objectid, for_reloc);
@@ -3466,7 +3466,7 @@ void btrfs_free_tree_block(struct btrfs_trans_handle *trans,
 		struct btrfs_ref generic_ref = {
 			.action = BTRFS_DROP_DELAYED_REF,
 			.bytenr = buf->start,
-			.len = buf->len,
+			.num_bytes = buf->len,
 			.parent = parent,
 			.owning_root = btrfs_header_owner(buf),
 			.ref_root = root_id,
@@ -3560,7 +3560,7 @@ int btrfs_free_extent(struct btrfs_trans_handle *trans, struct btrfs_ref *ref)
 	 * tree, just update pinning info and exit early.
 	 */
 	if (ref->ref_root == BTRFS_TREE_LOG_OBJECTID) {
-		btrfs_pin_extent(trans, ref->bytenr, ref->len, 1);
+		btrfs_pin_extent(trans, ref->bytenr, ref->num_bytes, 1);
 		ret = 0;
 	} else if (ref->type == BTRFS_REF_METADATA) {
 		ret = btrfs_add_delayed_tree_ref(trans, ref, NULL);
@@ -4967,7 +4967,7 @@ int btrfs_alloc_reserved_file_extent(struct btrfs_trans_handle *trans,
 	struct btrfs_ref generic_ref = {
 		.action = BTRFS_ADD_DELAYED_EXTENT,
 		.bytenr = ins->objectid,
-		.len = ins->offset,
+		.num_bytes = ins->offset,
 		.owning_root = root->root_key.objectid,
 		.ref_root = root->root_key.objectid,
 	};
@@ -5209,7 +5209,7 @@ struct extent_buffer *btrfs_alloc_tree_block(struct btrfs_trans_handle *trans,
 		struct btrfs_ref generic_ref = {
 			.action = BTRFS_ADD_DELAYED_EXTENT,
 			.bytenr = ins.objectid,
-			.len = ins.offset,
+			.num_bytes = ins.offset,
 			.parent = parent,
 			.owning_root = owning_root,
 			.ref_root = root_objectid,
@@ -5594,7 +5594,7 @@ static noinline int do_walk_down(struct btrfs_trans_handle *trans,
 		struct btrfs_ref ref = {
 			.action = BTRFS_DROP_DELAYED_REF,
 			.bytenr = bytenr,
-			.len = fs_info->nodesize,
+			.num_bytes = fs_info->nodesize,
 			.owning_root = owner_root,
 			.ref_root = root->root_key.objectid,
 		};
diff --git a/fs/btrfs/file.c b/fs/btrfs/file.c
index 416fa1f48fe5..c657dea23396 100644
--- a/fs/btrfs/file.c
+++ b/fs/btrfs/file.c
@@ -375,7 +375,7 @@ int btrfs_drop_extents(struct btrfs_trans_handle *trans,
 				struct btrfs_ref ref = {
 					.action = BTRFS_ADD_DELAYED_REF,
 					.bytenr = disk_bytenr,
-					.len = num_bytes,
+					.num_bytes = num_bytes,
 					.parent = 0,
 					.owning_root = root->root_key.objectid,
 					.ref_root = root->root_key.objectid,
@@ -468,7 +468,7 @@ int btrfs_drop_extents(struct btrfs_trans_handle *trans,
 				struct btrfs_ref ref = {
 					.action = BTRFS_DROP_DELAYED_REF,
 					.bytenr = disk_bytenr,
-					.len = num_bytes,
+					.num_bytes = num_bytes,
 					.parent = 0,
 					.owning_root = root->root_key.objectid,
 					.ref_root = root->root_key.objectid,
@@ -753,7 +753,7 @@ int btrfs_mark_extent_written(struct btrfs_trans_handle *trans,
 
 		ref.action = BTRFS_ADD_DELAYED_REF;
 		ref.bytenr = bytenr;
-		ref.len = num_bytes;
+		ref.num_bytes = num_bytes;
 		ref.parent = 0;
 		ref.owning_root = root->root_key.objectid;
 		ref.ref_root = root->root_key.objectid;
@@ -783,7 +783,7 @@ int btrfs_mark_extent_written(struct btrfs_trans_handle *trans,
 
 	ref.action = BTRFS_DROP_DELAYED_REF;
 	ref.bytenr = bytenr;
-	ref.len = num_bytes;
+	ref.num_bytes = num_bytes;
 	ref.parent = 0;
 	ref.owning_root = root->root_key.objectid;
 	ref.ref_root = root->root_key.objectid;
@@ -2326,7 +2326,7 @@ static int btrfs_insert_replace_extent(struct btrfs_trans_handle *trans,
 		struct btrfs_ref ref = {
 			.action = BTRFS_ADD_DELAYED_REF,
 			.bytenr = extent_info->disk_offset,
-			.len = extent_info->disk_len,
+			.num_bytes = extent_info->disk_len,
 			.owning_root = root->root_key.objectid,
 			.ref_root = root->root_key.objectid,
 		};
diff --git a/fs/btrfs/inode-item.c b/fs/btrfs/inode-item.c
index e24605df35bb..7565ff15a69a 100644
--- a/fs/btrfs/inode-item.c
+++ b/fs/btrfs/inode-item.c
@@ -673,7 +673,7 @@ int btrfs_truncate_inode_items(struct btrfs_trans_handle *trans,
 			struct btrfs_ref ref = {
 				.action = BTRFS_DROP_DELAYED_REF,
 				.bytenr = extent_start,
-				.len = extent_num_bytes,
+				.num_bytes = extent_num_bytes,
 				.owning_root = root->root_key.objectid,
 				.ref_root = btrfs_header_owner(leaf),
 			};
diff --git a/fs/btrfs/ref-verify.c b/fs/btrfs/ref-verify.c
index 1108be7a050c..94bbb7ef9a13 100644
--- a/fs/btrfs/ref-verify.c
+++ b/fs/btrfs/ref-verify.c
@@ -673,7 +673,7 @@ int btrfs_ref_tree_mod(struct btrfs_fs_info *fs_info,
 	int ret = 0;
 	bool metadata;
 	u64 bytenr = generic_ref->bytenr;
-	u64 num_bytes = generic_ref->len;
+	u64 num_bytes = generic_ref->num_bytes;
 	u64 parent = generic_ref->parent;
 	u64 ref_root = 0;
 	u64 owner = 0;
diff --git a/fs/btrfs/relocation.c b/fs/btrfs/relocation.c
index 9e460b79f8b2..9a5a9142ea53 100644
--- a/fs/btrfs/relocation.c
+++ b/fs/btrfs/relocation.c
@@ -1162,7 +1162,7 @@ int replace_file_extents(struct btrfs_trans_handle *trans,
 		key.offset -= btrfs_file_extent_offset(leaf, fi);
 		ref.action = BTRFS_ADD_DELAYED_REF;
 		ref.bytenr = new_bytenr;
-		ref.len = num_bytes;
+		ref.num_bytes = num_bytes;
 		ref.parent = parent;
 		ref.owning_root = root->root_key.objectid;
 		ref.ref_root = btrfs_header_owner(leaf);
@@ -1176,7 +1176,7 @@ int replace_file_extents(struct btrfs_trans_handle *trans,
 
 		ref.action = BTRFS_DROP_DELAYED_REF;
 		ref.bytenr = bytenr;
-		ref.len = num_bytes;
+		ref.num_bytes = num_bytes;
 		ref.parent = parent;
 		ref.owning_root = root->root_key.objectid;
 		ref.ref_root = btrfs_header_owner(leaf);
@@ -1392,7 +1392,7 @@ int replace_path(struct btrfs_trans_handle *trans, struct reloc_control *rc,
 
 		ref.action = BTRFS_ADD_DELAYED_REF;
 		ref.bytenr = old_bytenr;
-		ref.len = blocksize;
+		ref.num_bytes = blocksize;
 		ref.parent = path->nodes[level]->start;
 		ref.owning_root = src->root_key.objectid;
 		ref.ref_root = src->root_key.objectid;
@@ -1405,7 +1405,7 @@ int replace_path(struct btrfs_trans_handle *trans, struct reloc_control *rc,
 
 		ref.action = BTRFS_ADD_DELAYED_REF;
 		ref.bytenr = new_bytenr;
-		ref.len = blocksize;
+		ref.num_bytes = blocksize;
 		ref.parent = 0;
 		ref.owning_root = dest->root_key.objectid;
 		ref.ref_root = dest->root_key.objectid;
@@ -1419,7 +1419,7 @@ int replace_path(struct btrfs_trans_handle *trans, struct reloc_control *rc,
 		/* We don't know the real owning_root, use 0. */
 		ref.action = BTRFS_DROP_DELAYED_REF;
 		ref.bytenr = new_bytenr;
-		ref.len = blocksize;
+		ref.num_bytes = blocksize;
 		ref.parent = path->nodes[level]->start;
 		ref.owning_root = 0;
 		ref.ref_root = src->root_key.objectid;
@@ -1433,7 +1433,7 @@ int replace_path(struct btrfs_trans_handle *trans, struct reloc_control *rc,
 		/* We don't know the real owning_root, use 0. */
 		ref.action = BTRFS_DROP_DELAYED_REF;
 		ref.bytenr = old_bytenr;
-		ref.len = blocksize;
+		ref.num_bytes = blocksize;
 		ref.parent = 0;
 		ref.owning_root = 0;
 		ref.ref_root = dest->root_key.objectid;
@@ -2537,7 +2537,7 @@ static int do_relocation(struct btrfs_trans_handle *trans,
 			struct btrfs_ref ref = {
 				.action = BTRFS_ADD_DELAYED_REF,
 				.bytenr = node->eb->start,
-				.len = blocksize,
+				.num_bytes = blocksize,
 				.parent = upper->eb->start,
 				.owning_root = btrfs_header_owner(upper->eb),
 				.ref_root = btrfs_header_owner(upper->eb),
diff --git a/fs/btrfs/tree-log.c b/fs/btrfs/tree-log.c
index da319ffda4ee..d8e7eb53cd0b 100644
--- a/fs/btrfs/tree-log.c
+++ b/fs/btrfs/tree-log.c
@@ -764,7 +764,7 @@ static noinline int replay_one_extent(struct btrfs_trans_handle *trans,
 				struct btrfs_ref ref = {
 					.action = BTRFS_ADD_DELAYED_REF,
 					.bytenr = ins.objectid,
-					.len = ins.offset,
+					.num_bytes = ins.offset,
 					.owning_root = root->root_key.objectid,
 					.ref_root = root->root_key.objectid,
 				};